%Brandon Plubell
%ENGR 351
%Mass-Spring System
%See
%http://fweb.wallawalla.edu/class-wiki/index.php/Laplace_transforms:_Under-damped_Mass-Spring_System_on_an_Incline#Equation_of_Motion
%Redistribution is not allowed, though personal educational use is

clc
clear all
%clf                %for Octave
clf reset           %for Matlab
%%
%Set Constants
A=1/4;                              %Area of contact surface (m^2)
bt=1*10^-3;                         %Thickness of fluid (1mm, in terms of m)
mu=.06;                             %Value of viscocity (N*s/m^2)
lambda=(mu*A)/bt;                   %Variable to make later calculations easier
                                    %ends up with units N*s/m or kg/(m*s)

mass=45;                            %Mass of box (kg)
k=200;                              %Spring constant (N/m)

%Form of the response is a low pass, with
%H(s)=1/(s^2+(lambda/mass)*s+(k/mass))

%put in form
% num                              [1]
%                    ------------------------------
% denom        [1, lambda/mass, k/mass] 'dot' [s^2 s 1]

num=[1];
denom=[1 lambda/mass k/mass];
sys=tf(num,denom);                  %use the expanded version, not zeros and poles (factored)
figure(1)                           %force to use a single figure window for the bode
bode(sys)                           %automatically make a bode plot
grid on


%%
%Note!!! Do not change of  variables above this line without changing the inverse laplace (x)!
%The following section (t to x0) can be changed at will
t=linspace(0,30,10000);             %create a time interval for position function
theta=30;                           %incline plane angle (deg)
g=9.81;                             %acceleration due to gravity, down positive (m/s^2)
v0=0;				            	%initial velocity of box with down in diagram positive (m/s)
x0=-0.5;                       		%initial position of box with down in diagram positive (m)

%Laplace Transforms of
%ang : variable to make typing equation easier
%A : 1/(s*(s^2+lambda/mass*s+k/mass))
%B : s/(s^2+lambda/mass*s+k/mass)
%C : 1/(s^2+lambda/mass*s+k/mass)
ang=(sqrt(159)*t)/6;
A=exp(-t/6).*(-9/40*cos(ang)-3*sqrt(159)/2120*sin(ang))+9/40;
B=exp(-t/6).*(cos(ang)-(sqrt(159)/159)*sin(ang));
C=exp(-t/6).*(2*sqrt(159)/53*sin(ang));

%Position Equation
x=g*sind(theta)*A + x0*B + v0*C + lambda/mass*x0*C;

figure(2);                          %force to use a different figure window than above
plot(t,x)
title('Equation of Motion','Fontsize',16)
xlabel('Time (s)','Fontsize',12)
ylabel('Position (m) in x Direction','Fontsize',12)
